// setupDlg.cpp : implementation file
//

#include "stdafx.h"
#include <winsvc.h>

#include "setup.h"
#include "setupDlg.h"
#include "dow95.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetupDlg dialog

CSetupDlg::CSetupDlg (CWnd* pParent /*=NULL*/)
: CDialog (CSetupDlg::IDD, pParent)
{ // -- CSetupDlg::CSetupDlg -- // 

    //{{AFX_DATA_INIT(CSetupDlg)
    // NOTE: the ClassWizard will add member initialization here
    //}}AFX_DATA_INIT
    // Note that LoadIcon does not require a subsequent DestroyIcon in Win32

    m_hIcon = AfxGetApp ()->LoadIcon (IDI_ICON1);

} // -- CSetupDlg::CSetupDlg -- // 

void CSetupDlg::DoDataExchange (CDataExchange* pDX)
{ // -- CSetupDlg::DoDataExchange -- // 

    CDialog::DoDataExchange (pDX);
    //{{AFX_DATA_MAP(CSetupDlg)
    // NOTE: the ClassWizard will add DDX and DDV calls here
    //}}AFX_DATA_MAP

} // -- CSetupDlg::DoDataExchange -- // 

BEGIN_MESSAGE_MAP(CSetupDlg, CDialog)
//{{AFX_MSG_MAP(CSetupDlg)

ON_WM_PAINT()
ON_WM_QUERYDRAGICON()
ON_BN_CLICKED(IDC_REMOVE, OnRemove)
ON_BN_CLICKED(IDC_CHECK1, OnCheck1)

//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetupDlg message handlers

BOOL CSetupDlg::OnInitDialog ()
{ // -- CSetupDlg::OnInitDialog -- // 

    OSVERSIONINFO osvi;
    CDialog::OnInitDialog ();
    
    
    // Set the icon for this dialog.  The framework does this automatically
    // when the application's main window is not a dialog
    SetIcon (m_hIcon, TRUE);			// Set big icon
    SetIcon (m_hIcon, FALSE);		// Set small icon
    
    // TODO: Add extra initialization here
    PResultStatic = (CEdit *)   GetDlgItem (IDC_EDIT1);
    PCheckBox =     (CButton *) GetDlgItem (IDC_CHECK1);
    PCheckBox2 =    (CButton *) GetDlgItem (IDC_CHECK2);
    PCheckBox-> SetCheck (1);
    PCheckBox2->SetCheck (1);
    PCheckBox2->EnableWindow (FALSE);
    memset (&osvi, 0, sizeof (OSVERSIONINFO));
    osvi.dwOSVersionInfoSize = sizeof (OSVERSIONINFO);
    GetVersionEx (&osvi);
    
    if (osvi.dwPlatformId != VER_PLATFORM_WIN32_NT)
    {
        PCheckBox->ShowWindow (SW_HIDE);
        PCheckBox2->ShowWindow (SW_HIDE);
    }

    return TRUE;  // return TRUE  unless you set the focus to a control

} // -- CSetupDlg::OnInitDialog -- // 

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSetupDlg::OnPaint () 
{ // -- CSetupDlg::OnPaint -- // 

    if (IsIconic ())
    {
        CPaintDC dc (this); // device context for painting
        
        SendMessage (WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc (), 0);
        
        // Center icon in client rectangle
        int cxIcon = GetSystemMetrics (SM_CXICON);
        int cyIcon = GetSystemMetrics (SM_CYICON);
        CRect rect;
        GetClientRect (&rect);
        int x = (rect.Width() - cxIcon + 1) / 2;
        int y = (rect.Height () - cyIcon + 1) / 2;
        
        // Draw the icon
        dc.DrawIcon (x, y, m_hIcon);
    }
    else
    {
        CDialog::OnPaint ();
    }

} // -- CSetupDlg::OnPaint -- // 

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSetupDlg::OnQueryDragIcon ()
{ // -- CSetupDlg::OnQueryDragIcon -- // 

    return (HCURSOR) m_hIcon;

} // -- CSetupDlg::OnQueryDragIcon -- // 

void CSetupDlg::OnOK () 
{ // -- CSetupDlg::OnOK -- // 
    
    OSVERSIONINFO osvi;
    char SystemDir[360];
    
    memset (&osvi, 0, sizeof (OSVERSIONINFO));
    osvi.dwOSVersionInfoSize = sizeof (OSVERSIONINFO);
    GetVersionEx (&osvi);
    
    // Main branch selects operating platform Win32, NT, or other.
    if (osvi.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS)
    {
        if (GetSystemDirectory (SystemDir, 360))
        {
            strcat (SystemDir,"\\vsauthd.vxd");
            if (CopyFile ("vsauthd.vxd", SystemDir, FALSE))
            {
                if (dowcheck ())
                {
                    PResultStatic->SetWindowText ("Windows 95 Device Driver Installed Successfully.");
                }
                else
                {
                    PResultStatic->SetWindowText ("Failed to install Windows 95 Device Driver.");
                }
                
            }
            else if (dowcheck ())
            {
                PResultStatic->SetWindowText ("Windows 95 Device Driver Installed Successfully.");
            }
            else
            {
                PResultStatic->SetWindowText ("Failed to install Windows 95 Device Driver.");
            }
        }
        else
        {
            PResultStatic->SetWindowText ("Failed to install Windows 95 Device Driver.");
        }
        
    }
    else if (osvi.dwPlatformId == VER_PLATFORM_WIN32_NT)
    {
        if (PCheckBox2->GetCheck ())
        {
            if (GetSystemDirectory (SystemDir, 360))
            {
                strcat (SystemDir, "\\drivers\\ds1410d.sys");
                OnRemove ();
                if (CopyFile ("ds1410d.sys", SystemDir, FALSE))
                {
                    if (dowcheck ())
                    {
                        PResultStatic->SetWindowText ("Windows NT Device Driver Installed Successfully.");
                        if (PCheckBox->GetCheck ())
                        {
                            InstallVDD ();
                        }
                    }
                    else
                    {
                        PResultStatic->SetWindowText ("Failed to install Windows NT Device Driver.");
                    }
                }
                else if (dowcheck ())
                {
                    PResultStatic->SetWindowText ("Windows NT Device Driver Installed Successfully.");
                    if (PCheckBox->GetCheck ())
                    {
                        InstallVDD ();
                    }
                }
                else
                {
                    PResultStatic->SetWindowText ("Failed to install Windows NT Device Driver.");
                }
            }
            else
            {
                PResultStatic->SetWindowText ("Failed to install Windows NT Device Driver.");
            }
            
            // Now check for service pack 2.
            if (!NTVDMDateOK ())
            {
                ::MessageBox (NULL, "NOTE: NT 4.0 will require service pack #2 or greater\n"
                                    "in order for these drivers to function correctly.\n"
                                    "This was not detected on your computer.",
                              "Service Pack Problem", MB_OK);
            }
        }
        
        
    }
    else
    {
        PResultStatic->SetWindowText ("No Device Driver Needed.");
    }
    
} // -- CSetupDlg::OnOK -- // 

void CSetupDlg::OnRemove () 
{ // -- CSetupDlg::OnRemove -- // 

    // TODO: Add your control notification handler code here
    
    SC_HANDLE hSCManager, hDS1410D;
    BOOL Ret;
    char Service[] = "DS1410D";
    OSVERSIONINFO osvi;
    char SystemDir[360];
    
    memset (&osvi, 0, sizeof (OSVERSIONINFO));
    osvi.dwOSVersionInfoSize = sizeof  (OSVERSIONINFO);
    GetVersionEx (&osvi);

    // Main branch selects operating platform Win32, NT, or other.
    if (osvi.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS)
    {
        if (GetSystemDirectory (SystemDir, 360))
        {
            strcat (SystemDir,"\\vsauthd.vxd");
            if (DeleteFile (SystemDir))
            {
                PResultStatic->SetWindowText ("Windows 95 Device Driver Removed Successfully.");
            }
            else
            {
                PResultStatic->SetWindowText ("Failed to delete Windows 95 Device Driver,\n"
                                              "make sure no programs are currently using the driver.");
            }
        }
        else
        {
            PResultStatic->SetWindowText ("Failed to delete Windows 95 Device Driver.");
        }
        
    }
    else if (osvi.dwPlatformId == VER_PLATFORM_WIN32_NT)
    {
        if (PCheckBox2->GetCheck ())
        {
            SERVICE_STATUS ServiceStatus;      
            /* Get a handle to the Service control manager database */
            hSCManager = OpenSCManager (
                NULL,
                NULL,
                SC_MANAGER_ALL_ACCESS);
            if (hSCManager)
            {
                hDS1410D = OpenService (
                    hSCManager,	
                    Service,	
                    SERVICE_ALL_ACCESS);
                if (hDS1410D)
                {
                    Ret = ControlService (hDS1410D, // handle to service 
                        SERVICE_CONTROL_STOP,	    // control code 
                        &ServiceStatus 	            // pointer to service status structure  
                        );
                    if (DeleteService (hDS1410D))
                    {
                        PResultStatic->SetWindowText ("Successfully deleted Windows NT device driver.");
                        GetSystemDirectory (SystemDir, 360);
                        strcat (SystemDir,"\\drivers\\ds1410d.sys");
                        DeleteFile (SystemDir);
                    }
                    else if (GetLastError () == ERROR_SERVICE_MARKED_FOR_DELETE)  
                    // Driver will be deleted when all handles have been closed.
                    {
                        PResultStatic->SetWindowText ("Successfully deleted Windows NT device driver");
                        GetSystemDirectory (SystemDir, 360);
                        strcat (SystemDir,"\\drivers\\ds1410d.sys");
                        DeleteFile (SystemDir);
                    }
                    else
                    {
                        PResultStatic->SetWindowText ("Failed to remove Windows NT device driver.");
                    }
                    CloseServiceHandle (hDS1410D);
                }
                else
                {
                    PResultStatic->SetWindowText ("Failed to remove Windows NT device driver.");
                }
                CloseServiceHandle (hSCManager);
            }
            else
            {
                PResultStatic->SetWindowText ("Failed to remove Windows NT device driver.");
            }
        }
        RemoveVDD ();
        RemoveVDD (); // for some reason that is beyond me, sometimes it takes two tries.
    }
    else
    {
        PResultStatic->SetWindowText ("No Device Driver to delete.");
    }
    
} // -- CSetupDlg::OnRemove -- // 

void CSetupDlg::InstallVDD ()
{ // -- CSetupDlg::InstallVDD -- // 

    char SubKey[] = "System\\CurrentControlSet\\Control\\VirtualDeviceDrivers"; 
    char ValueName[] = "VDD";
    char ValueData[360],ValueD[360];
    char CurrentPath[360], *p;
    DWORD cbData, Type, Size;
    DWORD ErrorValue;
    
    HKEY Result;
    GetCurrentDirectory (360, CurrentPath);
    if (GetSystemDirectory (ValueData, 360))
    {
        strcat (CurrentPath, "\\downtvdd.dll");
        strcat (ValueData, "\\downtvdd.dll");
        
        CopyFile (CurrentPath, ValueData, FALSE);
        if ((ErrorValue = RegOpenKeyEx (
            HKEY_LOCAL_MACHINE,	// handle of open key 
            SubKey,	            // address of name of subkey to open 
            0,	                // reserved 
            KEY_ALL_ACCESS,	    // security access mask 
            & Result            // address of handle of open key 
            )) == ERROR_SUCCESS)
        { // -- if RegOpenKeyEx succeeds -- // 
         		 
            cbData = strlen (ValueData);
            RegQueryValueEx (Result,
                ValueName,
                NULL,
                & Type,
                (unsigned char *) ValueD,
                & Size);
            // don't destroy any values that are already there
            if (Size == 2)
            {
                Size--;
            }

            p = ValueD+Size-1;
            strcpy (p, ValueData);
            strcat (p, "\0\0");
            cbData = Size + strlen (ValueData)+1;
            p = ValueD + cbData-1;
            *p = 0;

            if (RegSetValueEx (
                Result,	                // handle of key to set value for  
                ValueName,	            // address of value to set 
                0,	                    // reserved 
                REG_MULTI_SZ,	        // flag for value type 
                (const unsigned char *) ValueD, // address of value data 
                cbData 	                // size of value data 
                ) == ERROR_SUCCESS)
            { // -- RegSetValueEx successful -- // 

                PResultStatic->SetWindowText ("Windows NT device drivers installed successfully.");

            } // -- RegSetValueEx successful -- // 
            else
            {
                PResultStatic->SetWindowText ("Physical Device Driver installed correctly. "
                                              "Virtual Device Driver failed to install.");
            }

        } // -- if RegOpenKeyEx succeeds -- // 
        else
        {
            PResultStatic->SetWindowText ("Physical Device Driver installed correctly. "
                                          "Virtual Device Driver failed to install.");
        }
    }
    else
    {
        PResultStatic->SetWindowText ("Physical Device Driver installed correctly. "
                                      "Virtual Device Driver failed to install.");
    }
    
    
} // -- CSetupDlg::InstallVDD -- // 

void CSetupDlg::RemoveVDD ()
{ // -- CSetupDlg::RemoveVDD -- // 

    char SubKey[] = "System\\CurrentControlSet\\Control\\VirtualDeviceDrivers"; 
    char ValueName[] = "VDD", *p;
    char ValueData[360], ValueD[360],ValueTemp[20][360],ValueOld[360];
    DWORD cbData, Type, Size, i,j;
    DWORD ErrorValue;
    int len = 0;
    
    HKEY Result;
    if (GetSystemDirectory (ValueData, sizeof (ValueOld)))
    {
        strcat (ValueData, "\\downtvdd.dll");
        
        // Using DeleteFile to delete a system driver will not be 
        // successful under Windows NT.  In that case, rename the 
        // file and mark for deletion on reboot.
        if (!DeleteFile (ValueData))
        {
            GetSystemDirectory (ValueOld, sizeof (ValueOld));
            strcat (ValueOld, "\\downtvdd.del");
            
            // This should rename the file.
            MoveFileEx (
                ValueData,	                // address of name of the existing file  
                ValueOld,               	// address of new name for the file 
                MOVEFILE_REPLACE_EXISTING 	// flag to determine how to move file 
                );
            
            // This marks the file for deletion.
            MoveFileEx (
                ValueOld,
                NULL,
                MOVEFILE_DELAY_UNTIL_REBOOT
                );
        }


        RegFlushKey (HKEY_LOCAL_MACHINE);

        if ((ErrorValue = RegOpenKeyEx (
            HKEY_LOCAL_MACHINE,	    // handle of open key 
            SubKey,	                // address of name of subkey to open 
            0,	                    // reserved 
            KEY_ALL_ACCESS,	        // security access mask 
            &Result 	            // address of handle of open key 
            )) == ERROR_SUCCESS)
        { // -- if RegOpenKeyEx succeeds -- // 
            if (RegQueryValueEx (Result,
                ValueName,
                NULL,
                &Type,
                (unsigned char *) ValueD,
                &Size) == ERROR_SUCCESS)
            { // -- if RegQueryValueEx succeeds -- // 
                p = ValueD;
                i = 0;
                // *(p-1) is questionable on the first loop;
                while (*p || *(p-1))
                {
                    strcpy (ValueTemp[i],p);
                    p = p + strlen (ValueTemp[i])+1;
                    i++;
                }
                strcpy (ValueData, "");

                // Build a new string to set in the registry and 
                // remove any references to our string.
                p = ValueData;

                for (j = 0; j < i; j++)
                { // -- for -- // 
                    strupr (ValueTemp[j]);
                    if (!strstr (ValueTemp[j], "DOWNTVDD.DLL"))
                    {
                        strcpy (p, ValueTemp[j]);
                        len = len + strlen (ValueTemp[j])+1;
                        p += strlen (ValueTemp[j])+1;
                    }
                } // -- for -- // 

                *p = 0;
                cbData = len+1;
                if (cbData == 1)
                {
                    *(p+1) = 0;
                    cbData++;
                }
                if (RegSetValueEx (
                    Result,	        // handle of key to set value for  
                    ValueName,	    // address of value to set 
                    0,	            // reserved 
                    REG_MULTI_SZ,	// flag for value type 
                    (const unsigned char *)ValueData,   // address of value data 
                    cbData 	        // size of value data 
                    ) == ERROR_SUCCESS)
                { // -- if RegSetValueEx succeeds -- // 

                    PResultStatic->SetWindowText ("Windows NT device drivers removed successfully.");

                } // -- if RegSetValueEx succeeds -- // 
                else
                {
                    PResultStatic->SetWindowText ("Physical Device Driver removed correctly. "
                                                  "Virtual Device Driver failed to uninstall.");
                }
            } // -- if RegQueryValueEx succeeds -- // 
            else
            {
                PResultStatic->SetWindowText ("Physical Device Driver removed correctly. "
                                              "Please try again to remove Virtual Device Driver.");
            }

        } // -- if RegOpenKeyEx succeeds -- // 
        else
        {
            PResultStatic->SetWindowText ("Physical Device Driver removed correctly. "
                                          "Virtual Device Driver failed to uninstall.");
        }
        RegCloseKey (Result);
    }
    else
    {
        PResultStatic->SetWindowText ("Physical Device Driver removed correctly. "
                                      "Virtual Device Driver failed to uninstall.");
    }
} // -- CSetupDlg::RemoveVDD -- // 

void CSetupDlg::OnCheck1 () 
{ // -- CSetupDlg::OnCheck1 -- // 

    // TODO: Add your control notification handler code here
    if (PCheckBox->GetCheck () == 1)
    {
        PCheckBox2->SetCheck (1);
        PCheckBox2->EnableWindow (FALSE);
    }
    else
    {
        PCheckBox2->EnableWindow (TRUE);
    }
    
} // -- CSetupDlg::OnCheck1 -- // 


// NTVDMDateOK method should only be called if operating under NT 4.0.  This method returns a 
// (1) if okay, and (0) if there is a problem.  It checks the date of the file <NTVDM.EXE> to 
// see whether Service Pack #2 has been installed or not.  If anything unexpected happens, such 
// as not finding the OS main directory, or not finding the said file where it is supposed to be,
// or not successfully getting the time/date stamp of the file, then the function still succeeds, 
// only it will return a value other than one, in case the programmer wants to check this value.
int CSetupDlg::NTVDMDateOK (void)
{ // CSetupDlg::NTVDMDateOK

    char l_lpsWinDir[360];
    HANDLE l_tempHandle;
    FILETIME l_FileCreationStamp  = { 0 };
    FILETIME l_FileAccessStamp    = { 0 };
    FILETIME l_FileWriteStamp     = { 0 };
    LARGE_INTEGER l_tempInteger    = { 0 };


    // First of all, check version.  If not in Windows NT 4.0, then 
    // Service Pack #2 is not an issue.
    if ((_winmajor != 4) || (_winminor != 0))
    {
        return (1);
    }
    GetWindowsDirectory (l_lpsWinDir, 360);


    // If OS doesn't know its own directory, something is unusual.
    if (l_lpsWinDir == 0)
    {
        return (2);
        // By default,assume human understands what is happening.
    }
    
    strcat (l_lpsWinDir, "\\system32\\NTVDM.EXE");

    // Check for file existance.
    if ((l_tempHandle = CreateFile (l_lpsWinDir, 
            GENERIC_READ,           // Read.
            FILE_SHARE_READ,        // Allow subsequent share access.
            NULL,                   // No priveleges to child proc.
            OPEN_EXISTING,          // Do not create one.
            FILE_ATTRIBUTE_ARCHIVE, // This is expected.
            NULL                    // No file template used.
            )) == INVALID_HANDLE_VALUE)  // If invalid handle, function failed.
    {
        return (3);
        // By default,assume human understands what is happening.
    }


    // Get time stamps.
    if (!GetFileTime (l_tempHandle, &l_FileCreationStamp, &l_FileAccessStamp, &l_FileWriteStamp))
    {
        return (4);
        // By default,assume human understands what is happening.
    }

    CloseHandle (l_tempHandle);

    // MSDN library reccomends assigning timestamps to a LARGE_INTEGER & then performing ops.
    l_tempInteger.LowPart  = (l_FileWriteStamp.dwLowDateTime);
    l_tempInteger.HighPart = (l_FileWriteStamp.dwHighDateTime);


    if (l_tempInteger.QuadPart >= 124949088000000000)   
        // Compares to one second after midnight, 12/14/96.
        // 12/14/96 is the date of Service Pack 2.
    {

        return (1);
    }
    else
    {
        return (0);
    }

} // CSetupDlg::NTVDMDateOK
